package intermediate;

/**
 * Schemer symbol table entry.
 * @author Ronald Mak
 */
public class SymtabEntry 
{
    private String name;           // entry name
    private SymtabEntryType type;  // entry type
    private SymbolTable symtab;    // parent symbol table
    private Node node;             // tree node
    
    /**
     * Constructor.
     * @param name the name to enter.
     * @param type the type of entry.
     */
    public SymtabEntry(String name, SymtabEntryType type, SymbolTable symtab)
    {
        this.name   = name;
        this.type   = type;
        this.symtab = symtab;
        this.node   = null;
    }
    
    public String getName()          { return name; }
    public SymtabEntryType getType() { return type; }
    public SymbolTable getSymtab()   { return symtab; }
    public Node getNode()            { return node; }
    
    public void setSymtab(SymbolTable symtab) { this.symtab = symtab; }
    public void setNode(Node node)            { this.node = node; }
}
