package intermediate;

import java.util.ArrayList;

/**
 * The symbol table stack.
 */
public class SymtabStack 
{
    private static ArrayList<SymbolTable> stack = new ArrayList<>();
    private static int tos = -1;
    
    /**
     * Push a symbol table onto the stack.
     * @param symtab the symbol table to push.
     */
    public static void push(SymbolTable symtab)
    {
        ++tos;
        stack.add(symtab);
    }
    
    /**
     * Pop off and return the symbol table at the top of the stack.
     * @return the popped-off symbol table.
     */
    public static SymbolTable pop()
    {
        return stack.remove(tos--);
    }
    
    /**
     * Search the symbol table stack for a symbol.
     * @param symbol the symbol to find.
     * @return the symbol's entry if found, else null.
     */
    public static SymtabEntry find(String symbol)
    {
        // Search the stack from top to bottom.
        for (int i = tos; i >= 0; i--) {
            SymtabEntry entry = stack.get(i).find(symbol);
            if (entry != null) return entry;  // found
        }
        
        return null;  // not found
    }
}
